#include "chrono.h"

byte doQuit()
{ return yesNo("Quit game?") ? QUITGAME : 0;
}

byte doMove(byte c)
{ if(Plyr.move(keyToDir(c))) return RERENDER;
  return 0;
}

byte doMoveFarS(byte c)
{ if(Plyr.moveFarS(keyToDir(c))) return RERENDER;
  return 0;
}

byte doOpen()
{ int dir = askDir();
  if(dir == DIRINV) return 0;
  return Plyr.open(dir) ? RERENDER : 0;
}

byte doClose()
{ int dir = askDir();
  if(dir == DIRINV) return 0;
  return Plyr.close(dir) ? RERENDER : 0;
}

byte doPickup()
{ int i = Plyr.pos.y*MAPWID+Plyr.pos.x;
  if(!Lev.Items[i]) return 0;

  if(!Lev.Items[i]->next)
  { Plyr.pickup(Lev.Items[i], Lev.Items+i);
    return 0;
  }
  else
  { askItems(Lev.Items[i], MF_RELETTER|MF_SELMULTI|MF_ALLOWNUM);
    for(int j=0; j<MenuItems; j++)
      if(!Plyr.pickup((Item *)MenuReturn[j].assoc, Lev.Items+i)) break;
  }
  return REDRAW;
}

byte doDrop()
{ askItems(Plyr.inv, MF_SELMULTI|MF_ALLOWNUM);
  for(int i=0; i<MenuItems; i++)
    if(!Plyr.drop((Item *)MenuReturn[i].assoc, MenuReturn[i].count)) break;
  return REDRAW;
}

void doRecall(bool restart)
{ const char *str = recall(restart);
  if(str) printLine(str);
}

byte doGoDown()
{ return 0;
}

byte doGoUp()
{ return 0;
}
