#include "chrono.h"

Level    Lev;
Random   Rnd;
Console  Con;
Player   Plyr;
Coord    DirMap[8];

int initChrono()
{ DirMap[0] = Coord(0, -1), DirMap[1] = Coord(1,  -1), DirMap[2] = Coord( 1, 0),
  DirMap[3] = Coord(1,  1), DirMap[4] = Coord(0,   1), DirMap[5] = Coord(-1, 1),
  DirMap[6] = Coord(-1, 0), DirMap[7] = Coord(-1, -1);
  if(initItems()) return 1;
  if(initCreatures()) return 2;

  Con.setTitle("Chrono");
  Con.setSize(80, 50);
  Con.fill(0, 0, Con.Width, Con.Height, ' ', GREY);
  Rnd.Randomize();
  startGame();
  return 0;
}

void deinitChrono()
{ Con.setSize(80, 25);
  Con.fill(0, 0, Con.Width, Con.Height, ' ', GREY);
  Con.gotoXY(0, 0);
}

void startGame()
{ char buf[MAXLINE];
  Lev.deinit();
  Lev.init();

  Con.fill(0, 0, Con.Width, Con.Height, ' ', GREY);
  Con.gotoXY(0, 0);
  Con.putS("Chrono v. 0.10 built " __DATE__ " " __TIME__ "\n\n   Enter your name: ");
  Con.getS(buf, MAXLINE);
  
  if(Plyr.name) delete[] Plyr.name;
  int len = trim(buf);
  if(!len)
  { Plyr.name = new char[10];
    strcpy(Plyr.name, "John Doe");
  }
  else
  { Plyr.name = new char[len+1];
    strcpy(Plyr.name, buf);
  }
  clearOut();
  if(loadGame()) newGame();
  Lev.Map.updateVis(&Plyr);
  Lev.render();
  Lev.draw();
  Plyr.tell("Welcome to Chrono, %s! You are a mean, ugly, nasty human!", Plyr.name);
  Plyr.flush();
}

void newGame()
{ Lev.deinit();
  Lev.init();
  Lev.random();
  Lev.dlvl = 1;
}

int loadGame()
{ return 1;
}

int saveGame()
{ return 1;
}
