#ifndef _CREATURE_H
#define _CREATURE_H

#include "datatype.h"
#include "items.h"
#include <stdio.h>

int initCreatures();

struct Player;
extern Player Plyr;

extern CharData   CreatChars[];
extern CreatClass CreatClasses[CC_NUMCLASS];

Creature * newCreat(int type, int x=-1, int y=-1);
Creature * newCreatC(int cls, int x=-1, int y=-1);

#include <pshpack4.h>
struct Creature
{ Creature();
  virtual ~Creature();
  virtual Creature *clone() { return NULL; }
  int load(FILE *);
  int save(FILE *);

  virtual bool move(int dir);     // returns true if moved
  virtual bool moveFarS(int dir);

  virtual bool open(int dir);   // returns true if redraw needed-ie. door opened
  virtual bool close(int dir);

  // returns true if picked up (and removed from src), false if cant
  virtual bool pickup(Item *item, Item **src); 
  virtual bool drop(Item *item, int count=0); // returns true if dropped

  char Creature::freeLetter(Item * =NULL);    // returns a free inventory letter or 0

  Item * addItem(Item *item) { return ::addItem(&inv, item); }
  Item * remItem(Item *item, int count=0) { return ::remItem(&inv, item, count); }

  void addToBuffer(const char *, int len=-1);
  void flush();
  void tell1(const char *);
  void tell(const char *, ...);

  bool isPlayer()
  { return (this == (Creature *)&Plyr); }

  // basics
  Coord pos, last;
  int   type, clarse;
  DWORD flags;

  // inventory
  Item *inv;

  // more stats
  int lightrad, sightdist;

  // text
  char *name;
  const char *defname;
  const char *ysname();

  char *buffer;
  int   buflen;

  // creature management
  int   idTag;
};

struct Player : public Creature
{ enum {TYPE=CT_PLAYER};
  Player();
  virtual Creature *clone();
};
#include <poppack.h>

#endif
