#ifndef _DATATYPE_H
#define _DATATYPE_H

#include <windows.h>

#include <pshpack1.h>

union CharData
{ struct
  { byte c, attr; } b;
  WORD word;
};

struct Coord
{ Coord(){};
  Coord(int nx, int ny) : x(nx), y(ny) { };
  inline bool operator==(Coord c) { return x == c.x && y == c.y; }
  int x, y;
};

struct Dir
{ int dir;
  Dir(){};
  Dir(int d) { *this = d; }
  Dir operator=(int d) { dir = (d<0 ? d : d%8); return *this; }
  Dir operator++()     { if(++dir==8) dir=0; return *this; }
  Dir operator++(int)  { Dir temp=*this; ++(*this); return temp; }
  Dir operator--()     { if(--dir<0) dir=7; return *this; }
  Dir operator--(int)  { Dir temp=*this; --(*this); return temp; }
  operator int()       { return dir; }
};

struct ItemClass
{ const char *name;
  int   start, end;
};

struct CreatClass
{ const char *name;
  int   start, end;
};

struct Room
{ bool intersects(Room *r, int underlap=0)
  { if(area.right+ underlap < r->area.left  ||
       area.left - underlap > r->area.right ||
       area.bottom+underlap < r->area.top   ||
       area.top  - underlap > r->area.bottom)
        return false;
    return true;
  }
  Coord center()
  { return Coord((area.right-area.left+1)/2+area.left,
                 (area.bottom-area.top+1)/2+area.top);
  }
  int width()  { return area.right-area.left+1; }
  int height() { return area.bottom-area.top+1; }
  RECT area;// area is INCLUSIVE
  bool con; // connected to another room
};

struct MenuItem
{ char *str;
  void *assoc;
  DWORD flags, reserved, count;
  char  letter;
};

struct Item;
struct ItemEnumS
{ Item *root;
  ItemClass *cls;
  int  numcls;
};

struct Stair
{ Coord pos;
  bool  up;
};
#include <poppack.h>

#endif