#ifndef _ENUMS_H
#define _ENUMS_H

#include <windows.h>
enum // colors
{ BLACK=0, RED=FOREGROUND_RED, GREEN=FOREGROUND_GREEN, BLUE=FOREGROUND_BLUE,
  CYAN=GREEN|BLUE, PURPLE=RED|BLUE, BROWN=RED|GREEN, GREY=RED|GREEN|BLUE,
  LTBLACK=FOREGROUND_INTENSITY, LTRED=RED|LTBLACK, LTGREEN=GREEN|LTBLACK,
  LTBLUE=BLUE|LTBLACK, LTCYAN=CYAN|LTBLACK, MAGENTA=PURPLE|LTBLACK,
  YELLOW=BROWN|LTBLACK, WHITE=GREY|LTBLACK
};

enum // map layout types
{ MT_SOLID, MT_VERT, MT_HORZ,  MT_UPLEFT, MT_UPRIGHT, MT_DNLEFT, MT_DNRIGHT,
  MT_CROSS, MT_UPT,  MT_DOWNT, MT_LEFTT,  MT_RIGHTT,  MT_VOPEN,
  MT_HOPEN, MT_VCLOSED, MT_HCLOSED, MT_TREE, MT_ROOMFLOOR, MT_COORIDOR,
  MT_STAIRUP, MT_STAIRDOWN, MT_SHALLOW, MT_DEEP, MT_ICE, MT_LAVA,
  MT_NUMTYPES, MT_NONE=255
};

enum // map layout supertypes
{ NONE=0, D_OPEN, D_CLOSED, S_UP, S_DOWN, W_VERT, W_HORZ,
  W_CORNER, W_CROSS
};

enum
{ REDRAW=1, RERENDER=2, QUITGAME=3
};

enum // ascii key constants
{ CTRLA=1, CTRLB, CTRLC, CTRLD, CTRLE, CTRLF, CTRLG, CTRLH, CTRLI, CTRLJ,
  CTRLK,   CTRLL, CTRLM, CTRLN, CTRLO, CTRLP, CTRLQ, CTRLR, CTRLS, CTRLT,
  CTRLU,   CTRLV, CTRLW, CTRLX, CTRLY, CTRLZ, ESCAPE
};

enum // logical key map
{ K_UP='8', K_DOWN='2', K_RIGHT='6', K_LEFT='4', K_UPLEFT='7', K_UPRIGHT='9',
  K_DNLEFT='1', K_DNRIGHT='3', K_DIRSELF='5', K_QUIT=CTRLQ, K_OPEN='o',
  K_CLOSE='c', K_MOVEFARS='5', K_PICKUP=',', K_DROP='d', K_RECALL=CTRLP,
  K_GODOWN='>', K_GOUP='<'
};

enum // directions
{ DIRINV=-2, DIRSELF, UP, UPRIGHT, RIGHT, DNRIGHT, DOWN, DNLEFT, LEFT, UPLEFT
};

enum // menu flags
{ MF_RELETTER=1, MF_SELMULTI=2, MF_ALLOWNUM=4,    // menu flags
  MF_CHOSEN=1, MF_HEADER=2, MF_FIRST=4, MF_LAST=8 // menu item flags
};

enum // temp string IDs
{ TS_NONE, TS_ITEMENUM, TS_PLAYER
};

enum // creature classes
{ CC_PLAYER, CC_NUMCLASS
};

enum // creature types
{ CT_PLAYER, CT_NUMTYPES
};

enum // creature flags
{ CF_INSTORE=1
};

enum // item classes
{ IC_DUMMY, IC_NUMCLASS
};

enum // item types
{ IT_DUMMY, IT_NUMTYPES
};

enum // item flags
{ IF_INSTORE=1
};

#endif