#ifndef _INPUT_H
#define _INPUT_H

struct Item;
struct ItemClass;

bool doInput(); // returns false if quitting game

// returns char entered or 0 if bad input (ie, no match and no default)
byte doPrompt(char const *prompt, char const *sel=NULL,
              byte def=0, bool cs=true);

int  keyToDir(byte c);   // takes key, returns dir
int  letToInd(char let); // takes letter, returns index (0-51)
char indToLet(int ind);  // takes index (0-51), returns letter

inline bool yesNo(char const *prompt)     // returns true if yes
{ return doPrompt(prompt, "yN", 'N', false) == 'Y'; }
inline bool noYes(char const *prompt)
{ return doPrompt(prompt, "nY", 'Y', false) == 'Y'; }

int askDir();   // asks for and returns a direction
// takes an item root, asks for what items to choose
void askItems(Item *root, DWORD mflags, ItemClass *classes=NULL, int numcs=0);

#endif