#ifndef _LEVEL_H
#define _LEVEL_H

#include <stdio.h>
#include "datatype.h"
#include "map.h"
#include "creature.h"
#include "config.h"

struct Item;

struct Level
{ Level();
  ~Level();

  int  init();
  void deinit();

  int  save(FILE *);                  // returns 0 on success
  int  load(FILE *);
  int  random();

  virtual Item * addItem(int x, int y, Item *);
  virtual Item * remItem(int x, int y, Item *, int=0);
  Coord   freeSpace(bool roomonly);

  void    render();
  void    draw();

  CMap      Map;
  Item     *Items[MAPWID*MAPHEI];

  Creature  Creats[MAXCREATS];
  int       numCreats;
  int       dlvl;
};

#endif
