#include "chrono.h"

MenuItem *MenuReturn;
int       MenuItems;

static MenuItem Items[52];
static int maxItems;

static char getChoice(int num, int *index, int *count)
{ char buf[16];
  int  i=0;
  char c;

  Con.putS("Enter selection: ");
  while(!isalpha(buf[i] = Con.getch()))
  { if(!isalnum(buf[i])) return buf[i];
    i++;
  }
  c = buf[i];
  buf[++i] = 0;
  *count = atoi(buf);
  for(i=0;i<num;i++)
  { if(Items[i].letter == c)
    { *index = i;
      return c;
    }
  }
  *index = -1;
  return c;
}

void updateItem(int i, int x, int count, bool nums)
{ if(Items[i].flags & MF_HEADER)
  { Items[i].flags &= ~MF_CHOSEN;
    return;
  }
  Con.gotoXY(x, Items[i].reserved);
  if(!nums) Con.putch((Items[i].flags & MF_CHOSEN) ? '+' : '-');
  else
  { if(count) Con.printF("%3d", count);
    else Con.putS((Items[i].flags & MF_CHOSEN) ? " + " : " - ");
  }
}

void doMenu(RECT *wnd, DWORD flags, DWORD pass, bool (*enumerate)(MenuItem *, DWORD))
{ int  xs  = wnd->left+1, ys = wnd->top+1, ye = wnd->bottom-1, y;//xe = wnd->right-1, 
  //int  wid = xe-xs+1, hei = ye-ys+1, y;
  int  i, let=0, items, count, miflags=MF_FIRST;
  char c;
  bool cont = true, multi = (flags&MF_SELMULTI)!=0,
       allownum = (flags&MF_ALLOWNUM)!=0;

  if(!MenuReturn) MenuReturn = new MenuItem[maxItems = 32];
  MenuItems = 0;

  while(cont)
  { byte next = !multi;
    y = ys;
    items = 0;
    while(items < 52 && y < ye)
    { Items[items].flags  = miflags;
      if(miflags) miflags = 0;
      if(!enumerate(Items+items, pass))
      { cont = false;
        break;
      }
      y++, items++;
    }
    clearOut(wnd);
    y = ys;
    for(i=0; i<items; y++,i++)
    { Items[i].reserved = y;
      if(Items[i].flags & MF_HEADER)
      { Con.gotoXY(xs, y);
        Con.putS(Items[i].str);
      }
      else
      { Con.gotoXY(xs+2, y);
        if(allownum) Con.putS("[ - ] ");
        else if(multi) Con.putS("[-] ");
        if(flags & MF_RELETTER)
        { Items[i].letter = indToLet(let++);
          if(let == 52) let = 0;
        }
        c = Items[i].letter;
        Con.printF("%c - %s", c, Items[i].str);
      }
    }
    do
    { Con.gotoXY(xs, y);
      c = getChoice(items, &i, &count);
      if(isalpha(c))
      { if(count != -1)
        { Items[i].count = count;
          if(!allownum) Items[i].flags ^= MF_CHOSEN;
          else 
          { if(count) Items[i].flags |= MF_CHOSEN;
            else Items[i].flags ^= MF_CHOSEN;
          }
          updateItem(i, xs+3, count, allownum);
        }
      }
      else
      { if(c == ',')
        { for(i=0; i<items; i++)
          { Items[i].flags |= MF_CHOSEN;
            updateItem(i, xs+3, 0, allownum);
          }
        }
        else if(c == '-')
        { for(i=0; i<items; i++)
          { Items[i].flags &= ~MF_CHOSEN;
            updateItem(i, xs+3, 0, allownum);
          }
        }
        else if(c == '/')
        { for(i=0; i<items; i++)
          { Items[i].flags ^= MF_CHOSEN;
            updateItem(i, xs+3, 0, allownum);
          }
        }
        else if(c == ' ' || c == '\t') next = 1;
        else if(c == '\r')        next = 2;
        else if(c == 27)          next = 3;
      }
    } while(!next);
    if(next == 3)
    { MenuItems = 0;
      break;
    }
    for(i=0; i<items; i++)
    { if(Items[i].flags & MF_CHOSEN)
      { if(MenuItems == maxItems)
        { MenuItem *more = new MenuItem[maxItems*2];
          memcpy(more, MenuReturn, maxItems*sizeof(MenuItem));
          maxItems *= 2;
          delete[] MenuReturn;
          MenuReturn = more;
        }
        if(!allownum) Items[i].count = 0;
        MenuReturn[MenuItems++] = Items[i];
      }
    }
    if(next == 2) break;
  }
  clearOut(wnd);
  Items[0].flags = MF_LAST;
  enumerate(Items, pass);
}