#include "chrono.h"
#include <ctype.h>

#include <pshpack1.h>
struct TempString
{ char *str;
  int   len;
  int   id;
};
#include <poppack.h>

static TempString *Temps;
static int         maxTemps;

int trim(char *str)
{ int s=0, e=strlen(str)-1;
  for(;s<=e;s++) if(!isspace(str[s])) break;
  for(;e>s;e--)  if(!isspace(str[e])) break;
  str[++e] = 0;
  if(s) memmove(str, str+s, e-s+1);
  return e-s;
}

char * getTempString(int id, int len)
{ int i;
  if(!Temps)
  { Temps = new TempString[maxTemps=64];
    memset(Temps, 0, maxTemps*sizeof(TempString));
  }

  for(i=0; i<maxTemps && Temps[i].id != TS_NONE; i++); // find suitable one

  if(i == maxTemps)
  { TempString *ts = new TempString[maxTemps*=2];
    memcpy(ts, Temps, i*sizeof(TempString));
    memset(ts+i, 0, i*sizeof(TempString));
    delete[] Temps;
    Temps = ts;
  }

  if(Temps[i].len < len)
  { delete[] Temps[i].str;
    Temps[i].str = new char[Temps[i].len = (len+64) & ~63];
  }
  Temps[i].id = id;
  Temps[i].str[0] = 0;
  return Temps[i].str;
}

void freeTempStrings(int id)
{ for(int i=0; i<maxTemps; i++) if(Temps[i].id == id) Temps[i].id = TS_NONE;
}
